<!--

############################# MicroTiddlyServer ################################

This PHP script allows TiddlyWiki to save directly onto an HTTP server.
To install, simply copy the index.php and the TiddlyWiki HTML file onto your web
server,  then open the address of this script in a web browser. You will then be
asked to perform some initial configuration,  after which you can then save your
wiki file on your website.

-->

<?php

$saveOnlineChanges = 'function saveOnlineChanges()
{
	var xmlhttp;
	function receiveOriginal()
	{
		if (xmlhttp.readyState == 4 && xmlhttp.status == 200)
		{
			// Concatenate all the tiddlers in the storeArea into proper HTML
			var d = "<div id=\"storeArea\">\n";
			store.forEachTiddler(function(title, tiddler) {
				d += "<div title=\"" + title + "\" ";
				if (tiddler.creator)
					d += "creator=\"" + tiddler.creator + "\" ";
				if (tiddler.modifier)
					d += "modifier=\"" + tiddler.modifier + "\" ";
				d += "created=\"" + tiddler.created.convertToYYYYMMDDHHMM() + "\" ";
				if (tiddler.modified && tiddler.created.convertToYYYYMMDDHHMM() != tiddler.modified.convertToYYYYMMDDHHMM())
					d += "modified=\"" + tiddler.modified.convertToYYYYMMDDHHMM() + "\" ";

				// Enumerate and save the custom fields
				for (key in tiddler.fields)
					d += key + "=\"" + tiddler.fields[key] + "\" ";
				if (tiddler.tags.length > 0)
				{
					var tags = "";
					for (var i=0; i<tiddler.tags.length; i++)
						tags += tiddler.tags[i] + " ";
					d += "tags=\"" + tags.trim() + "\" ";
				}
				var text = tiddler.text.replace(/&/g, "&amp;").replace(/>/g, "&gt;").replace(/</g, "&lt;").replace(/"/g, "&quot;");
				d += ">\n<pre>" + convertUnicodeToHtmlEntities(text) + "</pre>\n</div>\n";
			});
			d += "</div>\n";

			// Skip any comment at the start of the file
			var documentStart = this.responseText.indexOf("<!DOCTYPE");
			// Combine the document out of the parts that arent changed and the new data store area
			var st = this.responseText.indexOf("<!--POST-SHADOWAREA-->") + 23;
			var en = this.responseText.indexOf("<!--POST-STOREAREA-->");
			var newStore = this.responseText.substring(documentStart, st) + d + this.responseText.substring(en);
			
			// And save the new document using a HTML POST request
			xmlhttp=new XMLHttpRequest();
			xmlhttp.onreadystatechange=function()
			{
				if (xmlhttp.readyState==4 && xmlhttp.status==200)
				{
					//console.log("ajax success");
				}
			}
			xmlhttp.open("POST", doc, false);
			xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
			xmlhttp.send("save=yes&backupid=" + (new Date().convertToYYYYMMDDHHMMSSMMM()) + "&content=" + encodeURIComponent(newStore));
			store.setDirty(false);
		}
	}

	var doc = document.location.protocol + "//" + document.location.hostname + document.location.pathname;

	// Load the original
	xmlhttp=new XMLHttpRequest();
	xmlhttp.onreadystatechange=receiveOriginal;
	xmlhttp.open("GET", doc, false);
	xmlhttp.send();
}';

	$optionslink = 'http://' . $_SERVER['SERVER_NAME'] . $_SERVER['SCRIPT_NAME'] . '?options';
	$wikilink = 'http://' . $_SERVER['SERVER_NAME'] . $_SERVER['SCRIPT_NAME'];
	if (file_exists("options.txt"))
		$options = unserialize(file_get_contents("options.txt"));
	else
		$options = null;

	// If this is an AJAX request to save the file, do so
	if (isset($_POST['save']))
	{
		$content = $_POST['content'];
		file_put_contents("test.txt", $content);
		$backupid = preg_replace("/[^0-9\.]/", '', $_POST['backupid']);
		$s = strpos($content, "function saveOnlineChanges(");
		$e = strpos($content, "function saveMain(");
		$content = substr($content, 0, $s) . substr($content, $e);
		$content = preg_replace('/return saveOnlineChanges\(\);/', '', $content);
		copy($options['wikiname'], $options['wikiname'] . ".$backupid.html");
		file_put_contents("test.txt", $content);
		file_put_contents($options['wikiname'], $content);
	}
	else if (isset($_POST['options']))
	{
		// Make sure the selected wiki file is really in our directory
		if (strpos(realpath($_POST['wikiname']), getcwd()) === FALSE)
		{
			echo realpath($_POST['wikiname']) . ' is not in this directory';
			exit;
		}

		// Save the submitted options
		$options['wikiname'] = $_POST['wikiname'];
		file_put_contents("options.txt", serialize($options));
		echo 'Active wiki set to ' . $options['wikiname'] . '<br>';

		if (isset($_POST['setpassword']))
		{
			$un = preg_replace("/[^\w]/", "", $_POST['un']);
			$pw = preg_replace("/[^\w]/", "", $_POST['pw']);
			if ($un != $_POST['un'] || $pw != $_POST['pw'] || strlen($un) < 1 || strlen($pw) < 1)
			{
				echo 'The username or password contained illegal characters<br>';
				echo 'Use only letters (lower- and uppercase) and numbers<br>';
			}
			else
			{
				$htaccess = '<Files ~ "^\.(htaccess|htpasswd)$">
Deny from all
</Files>
<Files "options.txt">
Deny from all
</Files>
ErrorDocument 401 "401 - Wrong Password"
AuthName "Please enter your ID and password"
AuthType Basic
Require valid-user 
AuthGroupFile /dev/null
AuthUserFile ' . getcwd() . '/.htpasswd';
				$htpasswd = $un . ':' . crypt($pw, base64_encode($pw));
				echo "Username \"$un\" and Password set<br>";
				echo 'If you forget your password you can delete the .htaccess file through an FTP client to regain access<br>';
				file_put_contents(".htaccess", $htaccess);
				file_put_contents(".htpasswd", $htpasswd);
			}
		}

		echo "<p>To access this options page later, bookmark <a href='$optionslink'>$optionslink</a></p>";
		echo "<p>To start editing your TiddlyWiki now, go to <a href='$wikilink'>$wikilink</a></p>";
	}
	else if (isset($_GET['options']))
	{
		// Display the options menu
		echo '<html><head><title>TiddlyServer Options</title><script type="text/javascript">function check() { document.getElementById("un").disabled=!document.getElementById("spw").checked; document.getElementById("pw").disabled=!document.getElementById("spw").checked;  }</script></head><body>';
		echo "To access this options page later, bookmark <a href='$optionslink'>$optionslink</a><br>";
		echo '<form name="input" action="." method="post">';
		echo '<input type="hidden" name="options">';
		$files = scandir('.');
		echo 'Use this wiki file: <select name="wikiname">';
		foreach ($files as $i => $f)
		{
			if (substr_compare($f, ".html", -5, 5) != 0)
				continue;
			if (preg_match("/[0-9]{6}\.[0-9]{10}/", $f))
				continue;
			if ($f == '.' || $f == '..')
				continue;
			echo "<option value=\"$f\"";
			if ($f == $options['wikiname'])
				echo " selected";
			echo ">$f</option>\n";
		}
		echo '</select><br>';
		if (!file_exists('.htaccess'))
			echo '<div style="color: red">You currently do not have a password protecting your wiki file. If somebody guesses its path, he could modify it to include malicious javascript that steals your cookies and potentially leads to further hacking on your entire web site. Please set a password below.</div>';
		echo '<div style="border-width: 1px; border-style: solid; border-color: gray"><input onclick="check()" type="checkbox" name="setpassword" id="spw">Change or set a password<br>';
		echo 'Use only letters (lower- and uppercase) and numbers<br>';
		echo 'Username: <input type="text" name="un" id="un" disabled="disabled"><br>';
		echo 'Password: <input type="text" name="pw" id="pw" disabled="disabled"></div>';
		echo '<input type="submit" value="Save">';
		echo '</form>';
		echo '</body></html>';
	}
	else
	{
		$wikipath = $options['wikiname'];
			
		if (!file_exists($wikipath))
		{
			if (!$wikipath)
				echo 'MicroTiddlyServer is not yet configured<br>';
			else
				echo "Error $wikipath does not exist<br>";
			echo "Select a wiki file at <a href='$optionslink'>$optionslink</a>";
		}
		else
		{	
			$wikidata = file_get_contents($wikipath);

			preg_match('/version = {title: "TiddlyWiki", major: (\d+), minor: (\d+), revision: (\d+)/', $wikidata, $match);
			$version = intval($match[1]) * 10000 + intval($match[2]) * 100 + intval($match[3]);
			$versionstring = $match[1] . "." . $match[2] . "." . $match[3];

			// Check if this is a supported version
			if ($version == 20701 || $version == 20702 || $version == 20801)
			{
				// Inject the new saving function
				$x = strpos($wikidata, "function saveMain(");
				$wikidata = substr($wikidata, 0, $x) . $saveOnlineChanges . substr($wikidata, $x);

				// And the call to it
				$sc = strpos($wikidata, "function saveChanges(");
				$sc2 = strpos($wikidata, "clearMessage", $sc);
				$wikidata = substr($wikidata, 0, $sc2) . "return saveOnlineChanges();" . substr($wikidata, $sc2);

				// Patch the file to allow http saving
				$wikidata = preg_replace('/chkHttpReadOnly: true,/', 'chkHttpReadOnly: false,', $wikidata);

				print $wikidata;
			}
			else
			{
				echo "The TiddlyWiki file $wikipath has the version $versionstring which isn't compatible with MicroTiddlyServer<br>";
				echo 'You will have received a compatible wiki file with the name empty.html together with MicroTiddlyServer which you could use<br>';
				echo 'Or you could check for an update<br>';
				echo "Select a different wiki file at <a href='$optionslink'>$optionslink</a>";
			}
		}
	}

?>
